#include <file.au3>
#include <Array.au3>
#include <GuiConstants.au3>
Dim $array, $snrarray1, $snrarray2, $gpsarray, $file, $output, $temp, $date = "Unknown"
Dim $macadress[1], $kmlstring[1], $SNR[1]

GuiCreate("Netstumbler GPS Data to Google Earth KML - By:Andrew Calcutt", 510, 233,-1, -1 , BitOR($WS_OVERLAPPEDWINDOW, $WS_CLIPSIBLINGS))

GuiCtrlCreateLabel("Input File (.TXT)", 10, 10, 100, 20)
$gpsfileinput = GuiCtrlCreateInput("", 10, 30, 420, 20)
GuiCtrlCreateLabel("Output File (.KML)", 10, 60, 100, 20)
$kmlinput = GuiCtrlCreateInput("", 10, 80, 420, 20)
$browse1 = GuiCtrlCreateButton("Browse", 440, 30, 60, 20)
$browse2 = GuiCtrlCreateButton("Browse", 440, 80, 60, 20)
$scan = GuiCtrlCreateButton("Start", 190, 110, 110, 30)
$progressbar = GuiCtrlCreateProgress(10, 150, 490, 10)
GuiCtrlCreateLabel("Progress:", 10, 170, 50, 20)
$percentlabel = GuiCtrlCreateLabel("Ready", 60, 170, 160, 20)
GuiCtrlCreateLabel("Line/left:", 10, 190, 70, 20)
$line = GuiCtrlCreateLabel("", 60, 190, 160, 20)
GuiCtrlCreateLabel("Minutes:", 230, 170, 70, 20)
$minutes = GuiCtrlCreateLabel("", 290, 170, 70, 20)
GuiCtrlCreateLabel("Lines/Min:", 230, 190, 50, 20)
$linemin = GuiCtrlCreateLabel("", 290, 190, 60, 20)
GuiCtrlCreateLabel("Estimated time remaining:", 230, 210, 120, 20)
$estimatedtime = GuiCtrlCreateLabel("", 360, 210, 120, 20)
GuiCtrlCreateLabel("Total Lines:", 10, 210, 60, 20)
$totallines = GuiCtrlCreateLabel("", 80, 210, 130, 20)

GuiSetState()
While 1
	$msg = GUIGetMsg()
	Select
		Case $msg = $browse1
			GUICtrlSetData($gpsfileinput, FileOpenDialog("Select Netstumbler GPS File", @ScriptDir, "Netstumbler GPS File (*.txt)", 1))
		Case $msg = $browse2
			$temp = FileSaveDialog("Select Output Google Earth KML File", @ScriptDir, "Google Earth File (*.kml)")
			If @error <> 1 Then
				If StringInStr(StringRight ($temp, 4), ".kml") = 0 Then $temp &= ".kml"
				GUICtrlSetData($kmlinput, $temp)
			EndIf
		Case $msg = $scan
			$kml = GUICtrlRead($kmlinput)
			$gpsfile = GUICtrlRead($gpsfileinput)
			FileDelete($kml)
			;read ip address into array
			If Not _FileReadToArray($gpsfile, $gpsarray) Then
				MsgBox(4096, "Error", $gpsfile & 'Input File (' & $gpsfile & ')Not Found')
				Exit
			EndIf
			$file = '<?xml version="1.0" encoding="utf-8"?>' & @CRLF _
					 & '<kml xmlns="http://earth.google.com/kml/2.0">' & @CRLF _
					 & '<Document>' & @CRLF _
					 & '<Style id="secureStyle">' & @CRLF _
					 & '<IconStyle>' & @CRLF _
					 & '<scale>.5</scale>' & @CRLF _
					 & '<Icon>' & @CRLF _
					 & '<href>http://mboffin.com/earthstumbler/wap-secure.png</href>' & @CRLF _;image from EarthStubler
					 & '</Icon>' & @CRLF _
					 & '</IconStyle>' & @CRLF _
					 & '</Style>' & @CRLF _
					 & '<Style id="openStyle">' & @CRLF _
					 & '<IconStyle>' & @CRLF _
					 & '<scale>.5</scale>' & @CRLF _
					 & '<Icon>' & @CRLF _
					 & '<href>http://mboffin.com/earthstumbler/wap-open.png</href>' & @CRLF _;image from EarthStubler
					 & '</Icon>' & @CRLF _
					 & '</IconStyle>' & @CRLF _
					 & '</Style>' & @CRLF _
					 & '<Folder>' & @CRLF _
					 & '<description>Netstumbler Parser - By Andrew Calcutt</description>' & @CRLF _
					 & '<name>NetstublerToKML</name>' & @CRLF _
					 & '<Folder>' & @CRLF _
					 & '<name>Access Points</name>' & @CRLF _
					 & '<description>Access points found</description>' & @CRLF
			
			$begintime = TimerInit() ;starts counter
			GUICtrlSetData($totallines, $gpsarray[0])
			For $i = 1 To $gpsarray[0]
				_String($gpsarray[$i])
				$min = (TimerDiff($begintime) /60000) ;convert from miniseconds to minutes
				GUICtrlSetData($linemin, Round($i / $min, 4))
				GUICtrlSetData($minutes, Round($min, 4))
				GUICtrlSetData($line, $i & "/" & $gpsarray[0] - $i)
				GUICtrlSetData($estimatedtime, Round(($gpsarray[0] / Round($i / $min, 4))- $min, 4) & "/" & Round($gpsarray[0] / Round($i / $min, 4), 4))
			Next
			$macadress[0] = UBound($macadress) - 1
			$kmlstring[0] = UBound($kmlstring) - 1
			
			For $i = 1 To $kmlstring[0]
				$file &= $kmlstring[$i]
			Next
			
			$file &= '</Folder>' & @CRLF _
					 & '</Folder>' & @CRLF _
					 & '</Document>' & @CRLF _
					 & '</kml>' & @CRLF
			
			FileWrite($kml, $file)
			GUICtrlSetData($progressbar, 100)
			GUICtrlSetData($percentlabel, "Done")
			;FileMove($output, $kml, 1)
		Case $msg = $GUI_EVENT_CLOSE
			ExitLoop
		Case Else
			;;;
	EndSelect
WEnd



Func _String($string)
	If StringInStr($string, "# $DateGMT:") Then $date = StringTrimLeft($string, 12)
	If StringLeft($string, 1) <> "#" Then
		$array = StringSplit($string, "	")
		;_ArrayDisplay($array, "")
		If $string <> "" And IsArray($array) Then
			$snrarray1 = StringSplit($array[7], " ")
			If $array[1] <> "N 0.0000000" And $array[1] <> "N 360.0000000" And IsArray($snrarray1) Then
				;Start - thanks to "PsaltyDS" from the autoit forum :-)
				$HexIn = Number("0x" & $array[9])
				Global $ESS = False, $IBSS = False, $CFPoll = False, $CFPollReq = False, $WEP = False, $ShortPreAm = False, $PBCC = False, $ChAgile = False
				If BitAND($HexIn, 0x1) Then $ESS = True
				If BitAND($HexIn, 0x2) Then $IBSS = True
				If BitAND($HexIn, 0x4) Then $CFPoll = True
				If BitAND($HexIn, 0x8) Then $CFPollReq = True
				If BitAND($HexIn, 0x10) Then $WEP = True
				If BitAND($HexIn, 0x20) Then $ShortPreAm = True
				If BitAND($HexIn, 0x40) Then $PBCC = True
				If BitAND($HexIn, 0x80) Then $ChAgile = True
				
				$msg = "<br /><b>Flags: " & $array[9] & "</b>"
				If $HexIn Then
					If $ESS = True Then $msg &= "<br />ESS (Infrastructure)"
					If $IBSS = True Then $msg &= "<br />IBSS (Ad hoc)"
					If $CFPoll = True Then $msg &= "<br />CF: Pollable"
					If $CFPollReq = True Then $msg &= "<br />CF: Poll Request"
					If $WEP = True Then $msg &= "<br />Privacy (WEP)"
					If $ShortPreAm = True Then $msg &= "<br />Short Preamble"
					If $PBCC = True Then $msg &= "<br />PBCC"
					If $ChAgile = True Then $msg &= "<br />Channel Agility"
				EndIf
				;End - thanks to "PsaltyDS" from the autoit forum :-)
				$snrarray1 = StringSplit($array[7], " ")
				$temp = '<Placemark>' & @CRLF _
						 & '<name></name>' & @CRLF _
						 & '<description><![CDATA[<b>SSID: </b>' & $array[3] & '<br /><b>MAC: </b>' & $array[5] & '<br /><b>Date Found: </b>' & $date & '<br /><b>Time Found: </b>' & $array[6] & '<br /><b>SNR: </b>' & $snrarray1[2] & '<br /><b>Signal: </b>' & $snrarray1[3] & '<br /><b>Noise: </b>' & $snrarray1[4] & '<br /><b>Longitude: </b>' & $array[1] & '<br /><b>Latitude: </b>' & $array[2] & "<br />" & $msg & '<br />]]></description>'
				If $WEP = True Then
					$temp &= '	<styleUrl>#secureStyle</styleUrl>' & @CRLF
				Else
					$temp &= '	<styleUrl>#openStyle</styleUrl>' & @CRLF
				EndIf
				$temp &= '<Point>' & @CRLF _
						 & '<coordinates>' & StringReplace(StringReplace(StringReplace($array[2], 'W', '-'), 'E', ''), ' ', '') & ',' & StringReplace(StringReplace(StringReplace($array[1], 'S', '-'), 'N', ''), ' ', '') & ',0</coordinates>' & @CRLF _
						 & '</Point>' & @CRLF _
						 & '</Placemark>' & @CRLF
						 
				$found = _ArraySearch($macadress, $array[5]);search if mac is already in array. if it is update the inforamtion. if not, add it
				If $found = -1 Then
					_ArrayAdd($macadress, $array[5])
					_ArrayAdd($SNR, $snrarray1[2])
					_ArrayAdd($kmlstring, $temp)
				Else
					If $snrarray1[2] > $SNR[$found] Then
						$macadress[$found] = $array[5]
						$kmlstring[$found] = $temp
					EndIf
				EndIf
			EndIf
			
			;set progress
			
			$macadress[0] = UBound($macadress) - 1
			$percent = ($i / $gpsarray[0]) * 100
			GUICtrlSetData($progressbar, $percent)
			GUICtrlSetData($percentlabel, Round($percent, 4) & '% Array size:' & $macadress[0])
			
		EndIf
	EndIf
EndFunc   ;==>_String

#region --- GuiBuilder code Start ---
; Script generated by AutoBuilder 0.6 Prototype

#include <GuiConstants.au3>

GuiCreate("MyGUI", 510, 233,-1, -1 , BitOR($WS_OVERLAPPEDWINDOW, $WS_CLIPSIBLINGS))

GuiCtrlCreateLabel("Input File (.TXT)", 10, 10, 100, 20)
$gpsfileinput = GuiCtrlCreateInput("", 10, 30, 420, 20)
GuiCtrlCreateLabel("Output File (.KML)", 10, 60, 100, 20)
$kmlinput = GuiCtrlCreateInput("Input4", 10, 80, 420, 20)
$browse1 = GuiCtrlCreateButton("Browse", 440, 30, 60, 20)
$browse2 = GuiCtrlCreateButton("Browse", 440, 80, 60, 20)
$scan = GuiCtrlCreateButton("Start", 190, 110, 110, 30)
$progressbar = GuiCtrlCreateProgress(10, 150, 490, 10)
GuiCtrlCreateLabel("Progress:", 10, 170, 50, 20)
$percentlabel = GuiCtrlCreateLabel("Ready", 60, 170, 160, 20)
GuiCtrlCreateLabel("Line:", 10, 190, 40, 20)
$line = GuiCtrlCreateLabel("", 60, 190, 160, 20)
GuiCtrlCreateLabel("Minutes:", 230, 170, 70, 20)
$minutes = GuiCtrlCreateLabel("", 290, 170, 70, 20)
GuiCtrlCreateLabel("Lines/Min:", 230, 190, 50, 20)
$linemin = GuiCtrlCreateLabel("", 290, 190, 60, 20)
GuiCtrlCreateLabel("Estimated time remaining:", 230, 210, 120, 20)
$estimatedtime = GuiCtrlCreateLabel("", 360, 210, 120, 20)
GuiCtrlCreateLabel("Total Lines:", 10, 210, 60, 20)
$totallines = GuiCtrlCreateLabel("", 80, 210, 130, 20)

GuiSetState()
While 1
	$msg = GuiGetMsg()
	Select
	Case $msg = $GUI_EVENT_CLOSE
		ExitLoop
	Case Else
		;;;
	EndSelect
WEnd
Exit
#endregion --- GuiBuilder generated code End ---

